/* stats.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef STATS_H
#define STATS_H 1

#include <gtk/gtk.h>
#include "graphio.h"

#define TOP_MGN 16
#define LEFT_MGN 50
#define RIGHT_MGN 4
#define GAP 8
#define BOTTOM_MGN 28

class Main;
class Interface;
class Device;
class DataSet;
class Stats
{
	public:
		Stats(Main *m);
		~Stats();

		void show();
		void hide();
		void device_list();
		void set_interface_list();
//		void interface_list();
		void start_left();
		void start_right();
		void start_today();
		void start_all();
		void middle_left();
		void middle_right();
		void end_left();
		void end_right();

		void set_check(GtkWidget *w);
		void create_key(GtkWidget *vbox, char *label, int i, GdkColor col);
		void load();
		void draw();
		void draw_line(int var);

		Main *main;
		gint width, height;
		GdkPixmap *canvas;
		int BX, BY, BW, BH;
		int SX, SY, SW, SH;

		int length;			// number of days worth of data
		int day_range;	// the number of days to be shown
		TimeStamp gstart, gend;	// range of timestamps to be shown in the graph
		TimeStamp newest_time, oldest_time;

		GraphIO gio;
		DataSet *data;
		char *check_states;

		Device *current_router;
		Interface *current_interface;

		GdkGC *gc, *gridgc;
		GdkColor lightgray, gray, darkgray, black;

		GtkWidget *window;
		GtkWidget *clist5;
		GtkWidget *clist6;
		GtkWidget *combo3;
		GtkWidget *button1;
		GtkWidget *button2;
		GtkWidget *button3;
		GtkWidget *button4;
		GtkWidget *button5;
		GtkWidget *button6;
		GtkWidget *button13;
		GtkWidget *button15;
		GtkWidget *button16;
		GtkWidget *checkbutton1;
		GtkWidget *label46;
		GtkWidget *radio1;
		GtkWidget *radio2;
		GtkWidget *vbox19;
		GtkWidget *drawingarea1;
		GtkWidget *scrollbar;
		GtkAdjustment *scrollbar_adj;
		GtkWidget *pix[8];
		int scale;	// linear / log
};

#endif

