#include <stdlib.h>
#include <string.h>
#include "viewitem.h"

ViewItem::ViewItem()
{
	empty();
}

ViewItem::~ViewItem()
{
}

void ViewItem::empty()
{
	ip.empty();
	iface = 0;
	x = rand()%480;
	y = rand()%320;
	show = '1';
	group = 'n';
}

void ViewItem::savexml(xmlNodePtr xmlnode, char type)
{
	xmlNodePtr newxml;
	char buf[64];

	if (type=='d') strcpy(buf, "Device"); else
	if (type=='n') strcpy(buf, "Network"); else
		return;

	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)buf, NULL);
	xmlSetProp(newxml, (xmlChar*)"ip", (xmlChar*)ip.getstring());
	if (type=='n')
	{
		sprintf(buf, "%d", iface);
		xmlSetProp(newxml, (xmlChar*)"interface", (xmlChar*)buf);
		sprintf(buf, "%c", group);
		xmlSetProp(newxml, (xmlChar*)"view", (xmlChar*)buf);
	}
	if (type=='d')
	{
		sprintf(buf, "%c", group);
		xmlSetProp(newxml, (xmlChar*)"group", (xmlChar*)buf);
	}
	sprintf(buf, "%d", x);
	xmlSetProp(newxml, (xmlChar*)"x", (xmlChar*)buf);
	sprintf(buf, "%d", y);
	xmlSetProp(newxml, (xmlChar*)"y", (xmlChar*)buf);
	sprintf(buf, "%c", show);
	xmlSetProp(newxml, (xmlChar*)"show", (xmlChar*)buf);
}

void ViewItem::loadxml(xmlNodePtr xmlnode)
{
	xmlChar *buf;

	if (xmlnode->name && ((strcmp((char*)xmlnode->name, "Device")==0) ||
												(strcmp((char*)xmlnode->name, "Network")==0)))
	{
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"ip");
		if (buf!=NULL) { ip.setstring((char*)buf); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"x");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &x); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"y");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &y); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"interface");
		if (buf!=NULL) { sscanf((char*)buf, "%d", &iface); free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"show");
		if (buf!=NULL) { show = buf[0]; free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"group");
		if (buf!=NULL) { group = buf[0]; free(buf); }
		buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"view");
		if (buf!=NULL) { group = buf[0]; free(buf); }
	}
}

